Subject: Re: bug#39883: 28.0.50; macOS blank frame

From: Ashish SHUKLA <[email-masked]>
Date: Sun, 12 Apr 2020 11:54:53 +0530

On Apr 11, 2020, at 18:59, Alan Third <[email-masked]> wrote:
> 
> On Thu, Apr 02, 2020 at 11:49:45AM +0530, Ashish SHUKLA wrote:
>> On 4/2/20 12:23 AM, Alan Third wrote:
>>> 
>>> It’s quite possible we’ll need to provide some sort of option to force
>>> this, or to do run‐time feature detection. I don’t much fancy trying
>>> to code up the runtime detection for this feature, but if we need it
>>> we need it.
>> 
>> That definitely seems more foolproof. Let me know if you like me to test
>> your diff.
> 
> Can you please try the attached patches? The fix for this is built on
> the one for fixing frame resizing. Ultimately they should both end up
> on master, so I didn’t want to make separate branches and have to
> rework them later.
> 
> You may have to set this CFLAG to enable the changes:
> 
>    -DMAC_OS_X_VERSION_MAX_ALLOWED=101500
> -- 
> Alan Third
> <0001-Allow-dynamic-choice-of-drawing-path-on-NS-bug-39883.patch><v5-0001-Fix-NS-frame-resizing-issues-bug-40200-bug-28872.patch>

Hi

Without setting CFLAGS following error occurred:

==================================================================
  CC       image.o
  CC       json.o
  CC       nsterm.o
  CC       nsfns.o
  CC       nsmenu.o
  CC       nsselect.o
  CC       nsimage.o
  CC       macfont.o
  CC       terminfo.o
  CC       lastfile.o
nsterm.m:6300:21: error: use of undeclared identifier 'drawingBuffer'
  CGContextRelease (drawingBuffer);
                    ^
1 error generated.
make[1]: *** [Makefile:404: nsterm.o] Error 1
make[1]: *** Waiting for unfinished jobs....
make[1]: Leaving directory '/private/tmp/nix-build-emacs-git-20200412.0.drv-0/source/src'
make: *** [Makefile:424: src] Error 2
builder for '/nix/store/ipkfwl0i5xq2006g1j04nsh510y8snvn-emacs-git-20200412.0.drv' failed with exit code 2
cannot build derivation '/nix/store/0rq2gm9527ynz2f97xmlx4wpk5hpkly7-emacs-git-with-packages-20200412.0.drv': 1 dependencies couldn't be built
cannot build derivation '/nix/store/qkiy84nhzmzkkpkz9ayh6fivy1lp8s9j-hm_.configzsh.zshrc.drv': 1 dependencies couldn't be built
cannot build derivation '/nix/store/qz9gbgh031nlih9knmcbh8dk8g7c85q1-home-manager-files.drv': 1 dependencies couldn't be built
==================================================================

With CFLAGS set:

==================================================================
1 warning generated.
  CC       lastfile.o
In file included from <built-in>:360:
<command line>:4:9: warning: 'MAC_OS_X_VERSION_MAX_ALLOWED' macro redefined [-Wmacro-redefined]
#define MAC_OS_X_VERSION_MAX_ALLOWED 101500
        ^
<command line>:3:9: note: previous definition is here
#define MAC_OS_X_VERSION_MAX_ALLOWED 101200
        ^
nsterm.m:1148:8: error: use of undeclared identifier 'self'
  if ([self wantsUpdateLayer])
       ^
nsterm.m:1185:8: error: use of undeclared identifier 'self'
  if ([self wantsUpdateLayer])
       ^
nsterm.m:1234:12: error: use of undeclared identifier 'self'
      if ([self wantsUpdateLayer])
           ^
1 warning generated.
nsterm.m:1294:8: error: use of undeclared identifier 'self'
  if ([self wantsUpdateLayer])
111       ^ warning
 warning warning generated generated generated1.
.
.
1 warning generated warning.
 generated.
1 warning generated.
1 warning and 4 errors generated.
make[1]: *** [Makefile:404: nsterm.o] Error 1
make[1]: Leaving directory '/private/tmp/nix-build-emacs-git-20200412.0.drv-0/source/src'
make: *** [Makefile:424: src] Error 2
builder for '/nix/store/xf0x6mcjm6v4wn5zy0hnaicln7ipl9xc-emacs-git-20200412.0.drv' failed with exit code 2
cannot build derivation '/nix/store/hxcxbsby3vyf9apiq3zn9qvbjznz9bs5-emacs-git-with-packages-20200412.0.drv': 1 dependencies couldn't be built
==================================================================

The warning message "'MAC_OS_X_VERSION_MAX_ALLOWED' macro redefined” was emitted during compilation of every file.

FTR, I tested it with 43282a67[1].

References:
[1] https://git.savannah.gnu.org/cgit/emacs.git/commit/?id=43282a6772630275259dbc7560913c07f72eb06e

Thanks!
--
Ashish | GPG: F682 CDCC 39DC 0FEA E116  20B6 C746 CFA9 E74F A4B0

“Sometimes even to live is an act of courage.” (Seneca)